local io = io
local pairs = pairs
local ipairs = ipairs
local type = type
local tostring = tostring
local table = table
module(...)

local board = {
  ['NSGVM'] = {
    description = '4Eth, 1-USB, 4RS-232',
    eth = 4,
    usb = 1,
    rs232 = 4,
  },
}

deviceLongName = {
  eth = 'Eth',
  usb = 'USB',
  rs232 = 'RS-232',
  ['3g'] = '3G',
  edge = 'EDGE',
  cdma = 'CDMA EV-DO',
  wimax = 'WiMAX',
  wifi = 'Wi-Fi',
  ['1-wire'] = '1-Wire',
}
deviceList = {'eth', 'usb', 'rs232', '3g', 'edge', 'cdma',
'wimax', 'wifi', '1-wire'}

function set(bi)
--  local f = io.open("/proc/nsg/env")
--  local envStr, env = "", {}
--  if f then
--    envStr = f:read('*a')
--    f:close()
--  end
--  for k, v in envStr:gmatch"%s*([^%s=]*)%s*=([^\n]*)\n" do
--    if not env[k] then
--      env[k] = v
--    end
--  end
--  bi.env = env
  bi.serial = "1"
  bi.ethaddr = "00:09:56:86:XX:XX"
  local mach = "NSGVM"
  if mach then
    bi.mach = mach
    if board[mach] then
     for k, v in pairs(board[mach]) do
       bi[k] = v
     end
   end
  end

  local info = {}
  for _, dev in ipairs(deviceList) do
    local val = bi[dev]
    if val then
      local num, name = '', deviceLongName[dev] or tostring(dev)
      if type(val) == 'number' and val > 1 then
        num = tostring(val)..' '
      end
      info[#info+1] = num..name
    end
  end
  bi.ports = table.concat(info, ', ')
  bi.info = ([[
Device: %s
Ports:  %s
SN:     %s
MAC:    %s
]]):format(bi.mach, bi.ports, bi.serial, bi.ethaddr)
  return bi
end
