module(..., package.seeall)

local function _splitArgs(argstring)
  local fname = os.tmpname()
  local f = io.open(fname, 'w')
  f:write"local t={}for k,v in ipairs{...}do t[k]=('%q'):format(v)end io.write(table.concat(t,','))"
  f:close()
  f = io.popen("lua "..fname..' '..argstring)
  local s = f:read'*a'
  f:close()
  os.remove(fname)
  return loadstring('return{'..s..'}')()
end

function splitArgs(argstring)
  local res, argtabl = pcall(_splitArgs, argstring)
  if res then
    return argtabl
  else
    return nil, argtabl
  end
end

function getFile(filename)
  local f = io.open(filename)
  if f then
    local data = f:read'*a'
    f:close()
    if data then
      return data
    end
  end
  return nil
end

local toip = require'socket'.dns.toip
local ipaddressVal = require'scheme'.ipaddressVal
function gethostbyname(name)
  local dot = ipaddressVal(name)
  if dot then return dot end
  return toip(name)
end
